﻿using System.ServiceModel.Channels;

namespace TestServer
{
    /// <summary>
    /// 테스트 커스텀 바인딩
    /// </summary>
    public class TestCustomBinding : Binding
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 트랜스포트
        /// </summary>
        private HttpTransportBindingElement transport;

        /// <summary>
        /// 인코딩
        /// </summary>
        private BinaryMessageEncodingBindingElement encoding;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 스킴 - Scheme

        /// <summary>
        /// 스킴
        /// </summary>
        public override string Scheme
        {
            get
            {
                return this.transport.Scheme;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TestCustomBinding()

        /// <summary>
        /// 생성자
        /// </summary>
        public TestCustomBinding() : base()
        {
            this.transport = new HttpTransportBindingElement();
            this.encoding  = new BinaryMessageEncodingBindingElement();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 바인딩 엘리먼트 컬렉션 생성하기 - CreateBindingElements()

        /// <summary>
        /// 바인딩 엘리먼트 컬렉션 생성하기
        /// </summary>
        /// <returns>바인딩 엘리먼트 컬렉션</returns>
        public override BindingElementCollection CreateBindingElements()
        {
            BindingElementCollection collection = new BindingElementCollection();

            collection.Add(this.encoding);
            collection.Add(this.transport);

            return collection;
        }

        #endregion
    }
}