﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Configuration;
using System.ServiceModel.Channels;
using System.ServiceModel.Configuration;

namespace TestServer
{
    /// <summary>
    /// 테스트 커스텀 바인딩 컬렉션 엘리먼트
    /// </summary>
    public class TestCustomBindingCollectionElement : BindingCollectionElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 바인딩 타입 - BindingType

        /// <summary>
        /// 바인딩 타입
        /// </summary>
        public override Type BindingType
        {
            get
            {
                return typeof(TestCustomBinding);
            }
        }

        #endregion
        #region 구성 바인딩 컬렉션 - ConfiguredBindings

        /// <summary>
        /// 구성 바인딩 컬렉션
        /// </summary>
        public override ReadOnlyCollection<IBindingConfigurationElement> ConfiguredBindings
        {
            get
            {
                return new ReadOnlyCollection<IBindingConfigurationElement>(new List<IBindingConfigurationElement>());
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 키 포함 여부 구하기 - ContainsKey(name)

        /// <summary>
        /// 키 포함 여부 구하기
        /// </summary>
        /// <param name="name">명칭</param>
        /// <returns>키 포함 여부</returns>
        public override bool ContainsKey(string name)
        {
            throw new NotImplementedException();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 디폴트 구하기 - GetDefault()

        /// <summary>
        /// 디폴트 구하기
        /// </summary>
        /// <returns>바인딩</returns>
        protected override Binding GetDefault()
        {
            return new TestCustomBinding();
        }

        #endregion
        #region 추가 시도하기 - TryAdd(name, binding, configuration)

        /// <summary>
        /// 추가 시도하기
        /// </summary>
        /// <param name="name">명칭</param>
        /// <param name="binding">바인딩</param>
        /// <param name="configuration">구성</param>
        /// <returns>처리 결과</returns>
        protected override bool TryAdd(string name, Binding binding, Configuration configuration)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}